//=======================================================================================
//  USB ʼ, жϴ, ͻ, ͬӦûø 
//=======================================================================================
#include  "M451Series.h"
#include  "USB_define.h"

uint16_t gVCOMStatus ;                                     // BIT0: DTR , BIT1: RTS

#define	 FLAG_CTL_IN_FULL          0x01                    // ƴõı־
#define  FLAG_SET_ADDRESS          0x10
#define  FLAG_SET_CONFIG           0x20
#define  FLAG_SET_INTERFACE        0x40

/// VCOM Class request ////////////////////////////////////////////////////////////////
#define SET_LINE_CODE              0x20                    // Define CDC Class Specific Request
#define GET_LINE_CODE              0x21
#define SET_CONTROL_LINE_STATE     0x22

typedef struct{                                            // Setup  ݽṹ, 8ֽ
  unsigned char       RequestType ;                                 
  unsigned char       Request     ;
  unsigned char       ValueL      ;
  unsigned char       ValueH      ;
  unsigned short int  Index       ;
  unsigned short int  Length      ;
}USB_SETUP_Type ;

typedef struct DRVUSBD_CTRL_STRUCT{	                       // ڿƴ
	uint32_t  ReqLen;                                      //ݳȴʱ, շ
	uint32_t  Flag;                                        //ƴĸ׶
	uint8_t  *pSrc;                                        //ݶһʱ, ´η͵׵ַ
	uint8_t   Config;                                      //жʱ,浱ǰ,Ϊ0ʱʾδ
}USBD_CTRL_Type ;
volatile  USBD_CTRL_Type   gUsbCtrl ;                      

extern const uint8_t USB_DeviceDescriptor[]  ;
extern const uint8_t USB_ConfigDescriptor[]  ;
extern const uint8_t USB_StringLang[]        ;
extern const uint8_t USB_ProductStringDesc[] ;

extern void EndP2(void) ;
extern void EndP3(void) ;
extern void EndP4(void) ;
extern void EndP5(void) ;
extern void EndP6(void) ;
extern void EndP7(void) ;

//ָ궨壬עҪͳʼ USB_SRAM ĵַһ  
#define  pSetup                    ((USB_SETUP_Type*)USBD_BUF_BASE)    
#define  pEnd0Data                 ((uint8_t*)(USBD_BUF_BASE+64))      

//// USB ʼ =========================================================================
void USB_Init(void)
{
  uint32_t volatile temp ;
	
  SYS->IPRST1 |=  SYS_IPRST1_USBDRST_Msk ;                 // USB λ 
  USBD->SE0    = 1 ;	                                   // SE0״̬,
  temp         = 100 ;
  SYS->IPRST1 &= ~SYS_IPRST1_USBDRST_Msk ;
  while(temp--) __nop();   
                                                           // ƿ
  USBD->EP[0].CFG = (USBD_CFG_CSTALL | USBD_CFG_EPMODE_IN  | 0 ) ; //˵ַ:0
  USBD->EP[1].CFG = (USBD_CFG_CSTALL | USBD_CFG_EPMODE_OUT | 0 ) ; //˵ַΪ0,ҹһ
  USBD->EP[2].CFG = (USBD_CFG_CSTALL | USBD_CFG_EPMODE_IN  | 1 ) ; //˵ַ:1
  USBD->EP[3].CFG = (USBD_CFG_CSTALL | USBD_CFG_EPMODE_OUT | 2 ) ; //˵ַ:2
  USBD->EP[4].CFG = (USBD_CFG_CSTALL | USBD_CFG_EPMODE_IN  | 3 ) ; //˵ַ:3
                                                          
  USBD->STBUFSEG     = 0 ;                                 //Setup8ֽڴַ                           
  USBD->EP[0].BUFSEG = 64 ;				                         
  USBD->EP[1].BUFSEG = 64 ;				                   // ƿ, ݻַ
  USBD->EP[2].BUFSEG = 64+64 ;				                  
  USBD->EP[3].BUFSEG = 64*3 ;                    
  USBD->EP[4].BUFSEG = 64*4 ;                         
  USBD->EP[5].BUFSEG = 64*5 ;                         
  USBD->EP[6].BUFSEG = 64*6 ;                         
  USBD->EP[7].BUFSEG = 64*7 ;                         
                                                           // ʹж
  USBD->INTSTS = ~0 ; 
  USBD->INTEN  = USBD_INT_WAKEUP | USBD_INT_FLDET | USBD_INT_USB | USBD_INT_BUS ;
  NVIC_SetPriority (USBD_IRQn, 2);
  NVIC_EnableIRQ(USBD_IRQn);
  USBD->SE0    = 0 ;                                       // ͷ USB λ, ö
}

// Ctrl_IN , ״̬׶in 0ֽں, յ HOST  IN_ACK ============================
void USB_CtrlIn_Ack(void)
{
  uint32_t  Cnt = 0 ;                                      // ״̬׶OUT 0ֽ,׼

  switch (gUsbCtrl.Flag){                                  // ־, Ӧ 
    case FLAG_CTL_IN_FULL :                                // ϴ,                                       
      while(gUsbCtrl.ReqLen){ --gUsbCtrl.ReqLen ;
        pEnd0Data[Cnt] = *gUsbCtrl.pSrc++ ;
        if(++Cnt >= USB_EP0_PACKET_SIZE) break ;     
      }
      USBD->EP[0].MXPLD = Cnt ;
      if(Cnt != USB_EP0_PACKET_SIZE) gUsbCtrl.Flag = 0 ;   // ȫϴ
      return ;
                                                        
    case FLAG_SET_ADDRESS :                                // ״̬׶յ HOST IN_ACK
        USBD->FADDR = (pSetup->ValueL) ;                   // õַ,ƴOVER

    case FLAG_SET_CONFIG :                                 // ֻһúͽӿ,Բ
    case FLAG_SET_INTERFACE :
    default:                                               // ʡ gUsbCtrl.Flag     
      return ;    
  }
}

////  =============================================================================
void USB_ClassRequest(void)
{
  switch(pSetup->Request){
    case GET_LINE_CODE :
      pEnd0Data[0] = (char)115200 ;         pEnd0Data[1] = (char)(115200 >> 8) ; 
      pEnd0Data[2] = (char)(115200 >> 16) ; pEnd0Data[3] = (char)(115200 >> 24) ; 
      pEnd0Data[4] = 0 ;                                   // 1-stop
      pEnd0Data[5] = 0 ;                                   // No parity
      pEnd0Data[6] = 8 ;                                   // 8bit
      USBD->EP[0].CFG  |= 0x80 ;   
      USBD->EP[0].MXPLD = 7 ;                  
    
      USBD->EP[1].MXPLD = 0 ;                              // ״̬׶εOUT׼
      break ;
    
    case SET_LINE_CODE :                                  
      USBD->EP[1].MXPLD = 7 ;                              // Outʵݶ 
    
      USBD->EP[0].CFG  |= 0x80;   
      USBD->EP[0].MXPLD = 0;                               // ״̬׶׼
      break ;
    
    case SET_CONTROL_LINE_STATE : 
      gVCOMStatus = ((uint16_t)pSetup->ValueH << 8) + pSetup->ValueL ;  
    
      USBD->EP[0].CFG  |= 0x80;   
      USBD->EP[0].MXPLD = 0;                               // ״̬׶׼
      break ;
    
    default :
    USBD->EP[0].CFGP |= USBD_CFGP_SSTALL ;                 //֧ܲ,STALL
    USBD->EP[1].CFGP |= USBD_CFGP_SSTALL ;
  }
}

/// , Ϊ򻯴, ȡַ ====================================
void USB_GetDescriptor(void)
{
  uint32_t Cnt = 0 ;

  switch(pSetup->ValueH){                                  //ֽھʲô
    case DESC_DEVICE:                                      //豸 18ֽ
      gUsbCtrl.ReqLen = Minimum (pSetup->Length, (USB_DeviceDescriptor[3]<<8)|USB_DeviceDescriptor[2]);
      gUsbCtrl.pSrc = (uint8_t*)USB_DeviceDescriptor ;     
      break;                                              
	 
    case DESC_CONFIG:                                      //
      gUsbCtrl.ReqLen = Minimum (pSetup->Length, (USB_ConfigDescriptor[3]<<8)|USB_ConfigDescriptor[2]);
      gUsbCtrl.pSrc   = (uint8_t*)USB_ConfigDescriptor ;
      break;

    case DESC_STRING:                                      //
      if((pSetup->ValueL) == 0){                           // , 4ֽ
        gUsbCtrl.ReqLen = Minimum (pSetup->Length, USB_StringLang[0]);
        gUsbCtrl.pSrc   = (uint8_t*)USB_StringLang ; 
      }
      else if((pSetup->ValueL) == 2){                      // ûװʱʾ豸
        gUsbCtrl.ReqLen = Minimum (pSetup->Length, USB_ProductStringDesc[0]) ;
        gUsbCtrl.pSrc   = (uint8_t*)USB_ProductStringDesc ;
      }
      break;

    case DESC_HID :
    case DESC_HID_RPT :
    default:
      USBD->EP[0].CFGP |= USBD_CFGP_SSTALL ;               // ֧ܲ,STALL
      USBD->EP[1].CFGP |= USBD_CFGP_SSTALL ;
      return ;
  }
  
  while(gUsbCtrl.ReqLen){   --gUsbCtrl.ReqLen ;           
    pEnd0Data[Cnt] = *gUsbCtrl.pSrc++ ;                    // д˵0
    if(++Cnt >= USB_EP0_PACKET_SIZE) break ;
  }
  USBD->EP[0].MXPLD = Cnt ;                                // ϴ׼
  if(Cnt == USB_EP0_PACKET_SIZE) gUsbCtrl.Flag = FLAG_CTL_IN_FULL ;       
  return ;
}

//// ׼,ֻõļ,Լ򻯴 =======================================
static void USB_StandardRequest(void)
{
  switch (pSetup->Request){                                
    case GET_DESCRIPTOR :                                  //
      USB_GetDescriptor() ;                                //ЩIN, 
      USBD->EP[1].MXPLD = 0 ;                              //״̬׶εOUT׼
      return  ;

    case SET_ADDRESS:                                      //趨ַ
      gUsbCtrl.Flag = FLAG_SET_ADDRESS;                    //ַ
      USBD->EP[0].CFG   |= USBD_CFG_DSQSYNC_Msk ;    
      USBD->EP[0].MXPLD  = 0;                              //״̬׶׼
      return; 
 
    case SET_CONFIGURATION :                               //趨ֵ
      gUsbCtrl.Config   = pSetup->ValueL ;                 //ֵ
      USBD->EP[0].CFG  |= USBD_CFG_DSQSYNC_Msk;   
      USBD->EP[0].MXPLD = 0;                               //״̬׶׼
    
      USBD->EP[3].MXPLD = USB_PACKET_SIZE ;                //˵3 Rx׼
      return ; 
 
    case GET_CONFIGURATION :                               // ЩܿԲ֧
    case GET_INTERFACE :
    case SET_INTERFACE :
    case CLEAR_FEATURE :
    case SET_FEATURE :  
    case GET_STATUS : 

    default :
      USBD->EP[0].CFGP |= USBD_CFGP_SSTALL ;               // ֧ܲ,STALL
      USBD->EP[1].CFGP |= USBD_CFGP_SSTALL ;
      return ;
  }
}
//// USB շжϴ, SETUPж,8˵¼жϣøԵĴ ==============
void USB_UsbEvent(uint32_t u32IntSts)
{
  if(u32IntSts & USBD_INTSTS_SETUP_Msk){		   
    USBD->INTSTS     = (1ul<<31) ; 
    gUsbCtrl.Flag    = 0 ;                                 // ƴ俪ʼ
    USBD->EP[0].CFG |= USBD_CFG_DSQSYNC_Msk ;              // ΪIN_ACK׼,֮ǰSETUP,ԶToggle
    switch(pSetup->RequestType & 0x60){                    // D[6,5]
      case 0:                                              // 0x00, ׼
        USB_StandardRequest();          
        break;
      
      case 0x20:                                           // 0x20, 
        USB_ClassRequest();
        break;
      
      case 0x40:                                           // 0x40, Զ          
      default:                                             		   
        USBD->EP[0].CFGP |= USBD_CFGP_SSTALL ;             // ֧ܲ,STALL
        USBD->EP[1].CFGP |= USBD_CFGP_SSTALL ;
    }                      
  }
  else if(u32IntSts & 0x010000){                           // ƿ0, Ctrl_In,˵ַ: 0 
    USB_CtrlIn_Ack();
  }
  else if(u32IntSts & 0x020000){ //ƿ1 Ctrl_OUT , ״̬׶յ0ֽ,ѷ OUT_ACK 	  
    switch(gUsbCtrl.Flag){                                 // ־, Ӧ 
                                                         
    default :
      break ;		  
    }
  }
  else if(u32IntSts & 0x040000) EndP2() ;                  // ƿ2,Bulk_In, ˵ַ: 1 
  else if(u32IntSts & 0x080000) EndP3() ;
  else if(u32IntSts & 0x100000) EndP4() ;
  else if(u32IntSts & 0x200000) EndP5() ;
  else if(u32IntSts & 0x400000) EndP6() ;
  else if(u32IntSts & 0x800000) EndP7() ;
}

// USB ж,ĸжԴ: USBշж,¼ж,ж,ж=========================
void USBD_IRQHandler(void)
{
  uint32_t u32Status = USBD->INTSTS;

  if(u32Status & USBD_INTSTS_VBDETIF_Msk){                 // ж
    USBD->INTSTS = USBD_INTSTS_VBDETIF_Msk ;	           // ־
    if(USBD->VBUSDET & 1) USBD->ATTR = USBD_ATTR_PHYEN_Msk | USBD_ATTR_USBEN_Msk ; 
    else                  USBD->ATTR = 0 ;                 // USB,
  }

  else if(u32Status & USBD_INTSTS_BUSIF_Msk){              // Busж
    USBD->INTSTS = USBD_INTSTS_BUSIF_Msk ; 	         
    if(USBD->ATTR & USBD_ATTR_USBRST_Msk){                 // ߸λ
      USBD->ATTR |= USBD_ATTR_BYTEM_Msk | USBD_ATTR_PHYEN_Msk | USBD_ATTR_DPPUEN_Msk ; 		
      USBD->FADDR     = 0 ;	                               // ޵ַ
      gUsbCtrl.Config = 0 ;                                // 
	}
    else if(USBD->ATTR & USBD_ATTR_SUSPEND_Msk){           // ߹,PHY
      USBD->ATTR  &= ~USBD_ATTR_PHYEN_Msk ;                               
    }
    else if(USBD->ATTR & USBD_ATTR_RESUME_Msk){		       // ߻ָ
      USBD->ATTR  |=  USBD_ATTR_PHYEN_Msk  ;                    
    }
  }
  
  else if(u32Status & USBD_INTSTS_USBIF_Msk){              //USB շж
    USBD->INTSTS = USBD_INTSTS_USBIF_Msk ;    
    USB_UsbEvent(u32Status);                               // SETUP  8˵ݴ
  }

  else if(u32Status & USBD_INTSTS_NEVWKIF_Msk){            // Wake up ж
    USBD->INTSTS = USBD_INTSTS_NEVWKIF_Msk;                // ־
  }
}
